aboutsummaryrefslogtreecommitdiff
path: root/aux/workflow/assert-todos.sh
diff options
context:
space:
mode:
authorEuAndreh <eu@euandre.org>2021-02-08 21:44:24 -0300
committerEuAndreh <eu@euandre.org>2021-02-08 21:53:31 -0300
commitdd04e676719e18674fac0005ae77b0ebcf9d94b7 (patch)
tree81abc07a3c3abde06c0f009265119cf4383e608b /aux/workflow/assert-todos.sh
parentf581328141916e53a4c8999991c82a0e1b723067 (diff)
downloadpackage-repository-dd04e676719e18674fac0005ae77b0ebcf9d94b7.tar.gz
Add aux/ default files
Diffstat (limited to 'aux/workflow/assert-todos.sh')
-rwxr-xr-xaux/workflow/assert-todos.sh57
1 files changed, 57 insertions, 0 deletions
diff --git a/aux/workflow/assert-todos.sh b/aux/workflow/assert-todos.sh
new file mode 100755
index 0000000..203d465
--- /dev/null
+++ b/aux/workflow/assert-todos.sh
@@ -0,0 +1,57 @@
+#!/bin/sh
+set -eu
+
+if git grep FIXME | grep -v '^TODOs.md' | grep -v '^aux/workflow/assert-todos.sh' | grep -v '^aux/docbook-xsl/'; then
+ echo "Found dangling FIXME markers on the project."
+ echo "You should write them down properly on TODOs.md."
+ exit 1
+fi
+
+awk -F'{#' '
+BEGIN {
+ exitstatus = 0
+ h2flag = 0
+ h2status = ""
+ prevline = ""
+ idx = 0
+ delete ids[0]
+}
+h2flag == 1 {
+ split($0, l, " ")
+ timelinestatus = l[2]
+ if (h2status != timelinestatus) {
+ print "h2/timeline status mismatch for line " NR-1
+ print prevline
+ print $0
+ exitstatus = 1
+ }
+ h2status = ""
+ h2flag = 0
+}
+
+/^## (TODO|DOING|WAITING|MEETING|INACTIVE|NEXT|CANCELLED|DONE)/ {
+ if (match($0, / \{#.*?\}$/) == 0) {
+ print "Missing ID for line " NR ":\n" $0
+ exitstatus = 1
+ }
+ id_with_prefix = substr($2, 0, length($2) - 1)
+ match(id_with_prefix, /^\w+-/)
+ id = substr(id_with_prefix, RLENGTH + 1)
+ if (id in arr) {
+ print "Duplicate ID: " id
+ exitstatus = 1
+ } else {
+ arr[id] = 1
+ }
+
+ split($0, l, " ")
+ h2status = l[2]
+ h2flag = 1
+ prevline = $0
+}
+
+
+/^# Scratch$/ {
+ exit exitstatus
+}
+' TODOs.md